/* Common styles & classes
 *------------------------------------------------------------*/

.cl {clear: both;}
.fl {float: left;}
.fr {float: right;}
.oh {overflow: hidden;}

.align-left, .tal {text-align: left;}
.align-center, .tac {text-align: center;}
.align-right, .tar {text-align: right;}



/*------------------------------------------------------------
 * A bit more specific styles & classes
 *------------------------------------------------------------*/

.rounded { .border-radius; }
.circled { .border-radius(50%); }

img {
	max-width: 100%;
	vertical-align: middle;
	width: auto;
	height: auto;
}

.avatar { .circled; }



/* Hygge Inline List: Bullet, Slash, Dash
 *------------------------------------------------------------*/

.hygge-list--slash( @color: inherit ) {
	// float: left;
	display: inline-block;
	margin: 0;
	padding: 0;
	white-space: nowrap;

	&:after {
		display: inline-block;
		margin: auto 0.3em auto 0.7em;
		content: '/';
		color: @color !important; //prevent link hovers
		font-size: 1em;
	}

	&:last-child:after {
		content: none;
	}
}

.hygge-list--bullet( @color: inherit ) {
	// float: left;
	display: inline-block;
	margin: 0;
	padding: 0;
	white-space: nowrap;

	&:after {
		display: inline-block;
		margin: auto 0.4em auto 0.4em;
		content: '\000B7';
		color: @color !important; //prevent link hovers
	}

	&:last-child:after {
		content: none;
	}
}

.hygge-list--dash( @color: inherit ) {
	// float: left;
	display: inline-block;
	margin: 0;
	padding: 0;
	white-space: nowrap;

	&:after {
		display: inline-block;
		margin: auto 0.4em auto 0.4em;
		content: '-';
		color: @color !important; //prevent link hovers
	}

	&:last-child:after {
		content: none;
	}
}



/* Hygge UI: Arrows
 *------------------------------------------------------------*/

.hygge-ui-arrows {
	background: @white;
	overflow: hidden;

	& > * {
		float: left;
		display: block;
		width: 30px;
		text-align: center;

	}

	.hygge-ui-arrow {
		z-index: 2;
		padding: 10px 0;
		cursor: pointer;
		color: @black;
		background: @grey-pale;
		.transition;

		i { vertical-align: middle; }
		&--next { padding-left: 3px; }

		&:hover {
			color: @white;
			background: @primary-color;
		}
	}
}



/* Hygge UI: Dashed Pager
 *------------------------------------------------------------*/

.hygge-ui-pager {
	position: relative;
	padding: 10px 0 0;
	margin: 0 -4px;

	.widget & {
		margin-bottom: -10px;
	}

	.hygge-ui-pager__item {
		display: inline-block;
		margin-bottom: 0;
		width: 32px;
		height: 23px;
		padding: 10px 4px;
		cursor: pointer;

		&:after {
			content: "";
			display: block;
			width: 100%;
			height: 100%;
			background: @grey-light;
			.transition;

			.dark-mode & { background: @grey; }
		}

		&:hover {
			&:after {
				background: @grey;
				.dark-mode & { background: @grey-label; }
			}
		}

		&.active {
			pointer-events: none;
		}
	}

	.hygge-ui-pager__active-marker {
		position: absolute;
		left: 45%;
		top: 10px;
		opacity: 0;

		&:after {
			background: @black;
			.dark-mode & { background: @white; }
		}
	}
}



/* Back To Top
 *-------------------------------------------------------------*/

.hygge-btt {
	display: inline-block;
	z-index: 2;
	.circled;
	width: 50px;
	height: 50px;
	position: relative;
	overflow: hidden;
	background: @grey-light;
	vertical-align: middle;

	span,
	span:before,
	span:after {
		display: block;
		width: 14px;
		height: 2px;
		top: 25px;
		left: 19px;
		background: @black;
		.transition;

		.dark-mode & {
			background: @white;
		}
	}

	span {
		position: relative;
	}

	span:before,
	span:after {
		content: "";
		position: absolute;
		left: 0;
		top: 0px;
		width: 7px;
		transform-origin: 0% 50%;
		-webkit-transform-origin: 0% 50%;
	}

	span { .transform( ~"rotate3d(0,0,1,90deg)" ); }
	span:before { .transform( ~"rotate3d(0,0,1,40deg)" ); }
	span:after { .transform( ~"rotate3d(0,0,1,-40deg)" ); }

	&:hover {

		span,
		span:before,
		span:after {
			background: @white;
		}

		span {
			.transform( ~"rotate3d(0,0,1,0deg)" );
			left: 19px;
			top: 19px;
		}

		span:before,
		span:after {
			width: 9px;
			left: 0px;
			top: 7px;
			transform-origin: 50% 50%;
			-webkit-transform-origin: 50% 50%;
		}

		span:before {
			left: 6px;
		}
	}
}



/* Italic meta for hover overlay
 *------------------------------------------------------------*/

.italic-meta {
	text-align: center;
	line-height: 1.2 !important;

	.item {
		.hygge-list--dash;
	}

}



/* Hygge Color Media Hover
 *------------------------------------------------------------*/

.hygge-media-hover {
	position: relative;

	.hygge-media-hover__hover {
		.placement;
		background-color: @black;
		opacity: 0;
		pointer-events: none;
		backface-visibility: hidden;
		-webkit-backface-visibility: hidden;
		.transition;
	}

	.hygge-media-hover__img {
		@grayscale:
			-webkit-filter 0.25s cubic-bezier( 0.4, 0, 0.3, 1 ),
			filter 0.25s cubic-bezier( 0.4, 0, 0.3, 1 )
		;
		.transition(@grayscale);
	}

	.hygge-media-hover__details {
		position: absolute;
		top: 50%;
		left: 50%;
		.translate(-50%, -20%);
		-webkit-backface-visibility: hidden;
		width: 90%;
		opacity: 0;
		.transition;
	}

	&:hover {
		.hygge-media-hover__hover {
			opacity: 0.7;

			&.color-opacity-low {
				opacity: 0.2;
			}
		}

		.hygge-media-hover__img {
			filter: gray; /* IE 6-9 */
			-webkit-filter: grayscale(70%);
			filter: grayscale(70%);
		}

		.hygge-media-hover__details {
			opacity: 1;
			color: @black;
			.translate(-50%, -50%);

			.dark-mode& {
				color: @white;
			}
		}
	}

	&.has-thumbnail-false {
		.hygge-media-hover__hover {
			background: @white;
		}
	}
}



/* Hygge dropcap featured media
 *------------------------------------------------------------*/

.hygge-dropcap-media {
	position: relative;
	width: 100%;
	height: 0;
	padding-bottom: 100%;
	background: @grey-pale;

	.grey-mode & {
		background: @white;
	}

	&.ratio-horizontal { padding-bottom: 66.6%; }
	&.ratio-vertical { padding-bottom: 118%; }

	.letter {
		.placement;
		display: flex;
		align-items: center;
		justify-content: center;
		font-size: 120px;
		color: @black;
		opacity: 0.1;

		&--small {
			font-size: 70px;
		}

		.loop-container--style-widget-list &,
		.sidebar &,
		.hygge-sideblock & {
			font-size: 60px;
		}
	}

	&.dark-mode {
		.letter {
			color: @white;
			opacity: 0.2;
		}
	}
}



/* Hygge Slash:
 * Big pale slash to separate important UI elements
 *------------------------------------------------------------*/

.hygge-slash--big {
	display: inline-block;
	height: 50px;
	margin: -10px 25px 0;
	border-right: 1px solid @grey-light;
	vertical-align: middle;
	.transform(~"rotate(30deg)");

	.dark-mode & { border-right-color: fadein(@dark-border, 5%); }

	// make sure to align with other widgets
	.widget__title & {
		margin: -20px 30px 0;
		vertical-align: bottom;
	}
}
